#include <stdio.h>

extern struct rtpkt {
  int sourceid;       /* id of sending router sending this pkt */
  int destid;         /* id of router to which pkt being sent 
                         (must be an immediate neighbor) */
  int mincost[4];    /* min cost to node 0 ... 3 */
  };

extern int TRACE;
extern int YES;
extern int NO;

struct distance_table 
{
  int costs[4][4];
} dt0;

int connectcosts0[4] = { 0,  1,  3, 7 };

// caminhos minimos
int mincost0[4];

int noway0=4;
int myself0 = 0;
	
/* students to write the following two routines, and maybe some others */

void rtinit0() 
{
	
	int i,j;

	struct rtpkt packet;
	

	for (i=0; i<4; i++)
		for (j=0; j<4; j++)
		{
			if (j== noway0 || i == noway0)
				dt0.costs[i][j] = connectcosts0[noway0];		// no sei o caminho
			else
			{
				if (j == myself0)
					dt0.costs[i][j]= connectcosts0[i];	// link direto
				else if (i == myself0)
					dt0.costs[i][j]= 2 * connectcosts0[j];	// no sera usado
				else if (i == j)
					dt0.costs[i][j] = connectcosts0[i];	// link direto
				else 
					dt0.costs[i][j] = connectcosts0[j]* 2 + connectcosts0[i]; // vou para j, volto para 1, e vou para i (i atraves de j)
			}
		}
	
	
	if (TRACE>1)
	{	printf("\nTabela de distancias inicial do n %d:\n", myself0);			
		printdt0(&dt0);
	}

	// acha os caminhos minimos
	for(j=0;j<4;j++)
		mincost0[j] = dt0.costs[j][j];


	// envia os caminhos minimos para os vizinhos;
	for (i=0; i<4; i++)
		if (i!= myself0 && i!= noway0)
		{
			packet.destid = i;
			packet.sourceid= myself0;
			for(j=0;j<4;j++) 
				packet.mincost[j] = mincost0[j];
			tolayer2(packet);
		}
}



  
void rtupdate0(rcvdpkt)
  struct rtpkt *rcvdpkt;
{
	int change = 0;
	int i, j;
	struct rtpkt packet;
	
	j = rcvdpkt->sourceid;
	
	for(i=0; i<4; i++)
	{
		// se o caminho at J + o caminho at I for menor que o meu caminho minimo at I, atualiza a tabela
		if(mincost0[j] + rcvdpkt->mincost[i] < mincost0[i])
		{
			// atualiza os caminhos minimos
			mincost0[i] = mincost0[j] + rcvdpkt->mincost[i];
			// atualiza a tabela de distancia. Para ir at I atraves de J
			dt0.costs[i][j] = mincost0[i];
			change = 1;
		}
	}

	
	if (change)
	{
		if (TRACE>1)
		{	printf("\nTabela de distancias atualizada %d:\n", myself0);			
			printdt0(&dt0);
		}
		for (i=0; i<4; i++)
			if (i!= myself0 && i!= noway0)
			{
				packet.destid = i;
				packet.sourceid= myself0;
				for(j=0;j<4;j++) 
					packet.mincost[j] = mincost0[j];
				tolayer2(packet);
			}
	}
	
}


printdt0(dtptr)
  struct distance_table *dtptr;
  
{
  printf("                via     \n");
  printf("   D0 |    1     2    3 \n");
  printf("  ----|-----------------\n");
  printf("     1|  %3d   %3d   %3d\n",dtptr->costs[1][1],
	 dtptr->costs[1][2],dtptr->costs[1][3]);
  printf("dest 2|  %3d   %3d   %3d\n",dtptr->costs[2][1],
	 dtptr->costs[2][2],dtptr->costs[2][3]);
  printf("     3|  %3d   %3d   %3d\n",dtptr->costs[3][1],
	 dtptr->costs[3][2],dtptr->costs[3][3]);
}

linkhandler0(linkid, newcost)   
  int linkid, newcost;

/* called when cost from 0 to linkid changes from current value to newcost*/
/* You can leave this routine empty if you're an undergrad. If you want */
/* to use this routine, you'll need to change the value of the LINKCHANGE */
/* constant definition in prog3.c from 0 to 1 */
	
{
}

